.nh
.TH trial\-license\-cleaner
.SH NAME
.PP
trial\-license\-cleaner \- removes Trial licenses from nodes running IBM\-ICP4D OEM portworx builds, thus resetting the license SKU back to OEM.

.SH SYNOPSIS
.PP
trial\-license\-cleaner [options] px\-node

.SH Description
.PP
This tool is designed primarily to be ran proactively, to check the licenses before each \fB\fCpx\-2.3.1.1\fR to \fB\fCpx\-2.5.0.1\fR cluster upgrade, but it could also be used interactively to clean up Trial licenses on already upgraded \fB\fCpx\-2.5.0.1\fR clusters.

.PP
The tool has the following usage:

.PP
.RS

.nf
Usage: trial\-license\-cleaner [options] px\-node

SSH options:
  \-l <user>          Specifies the user to log in as on the remote machine  (default: $LOGNAME)
  \-i <pkey\-file>     Selects a file from which the identity (private key) for public key authentication is read
  \-\-passwd <secret>  Specify password to log in as on the remote machine (use '\-\-passwd ask' for interactive prompt)
  \-p <port>          Specify ssh service port  (default: 22)

Misc options:
  \-d <dir>           Specifies portworx binaries directory (default "/opt/pwx")
  \-E <dir>           Specifies portworx configuration directory (default "/etc/pwx")
  \-\-restart          Restart portworx services where license modified  (warn: all nodes in parallel)
  \-v, \-\-verbose      Verbose output
  \-V, \-\-version      Print version
  \-h, \-\-help         Print this help

EXAMPLES:
  trial\-license\-cleaner \-l root \-i $HOME/.ssh/id\_rsa\_deploy pxnode.company.com
  trial\-license\-cleaner \-l root \-v \-\-passwd ask http://pxnode.company.com:9001

.fi
.RE

.SH Requirements
.PP
The tool does not need to "run locally" on the node running Portworx, but will require remote access to nodes in the
Portworx cluster.  More specifically:

.RS
.IP "  1." 5
Tool requires SSH access to all the hosts running Portworx, and
.IP "  2." 5
Require network access to a (single) node running Portworx REST service.

.RE

.SS Required SSH access
.PP
The remote user needs to be able to run the \fB\fCsudo\fR commands on the remote nodes of the portworx cluster.

.PP
The supported SSH\-access methods:

.RS
.IP \(bu 2
[default] will try to utilize "ssh\-agent"  (if available)
.RS
.IP \(bu 2
for this access to work, the SSH\-agent needs to be initialized, and the required SSH keys need to be added into it via \fB\fCssh\-add $HOME/.ssh/id\_rsa\_XXX\fR command
.IP \(bu 2
this access supports password\-protected private SSH keys

.RE

.IP \(bu 2
[default] will try to use \fB\fC$HOME/.ssh/id\_rsa\fR private SSH key  (if available)
.RS
.IP \(bu 2
for this access to work, the \fB\fCid\_rsa\fR must \fInot\fP be password\-protected

.RE

.IP \(bu 2
\fB\fC\-i <ssh\-private\-key>\fR can be used to point to a non password\-protected SSH private key we want to use for the SSH access
.RS
.IP \(bu 2
using this method overrides default SSH access

.RE

.IP \(bu 2
\fB\fC\-passwd <password>\fR can be used to specify the SSH password
.RS
.IP \(bu 2
one can use \fB\fC\-passwd ask\fR to be interactively prompted for password
.IP \(bu 2
using this method overrides default SSH access

.RE


.RE

.SS Required access to Portworx REST service
.PP
The tool requires network access to one Portworx node from the cluster, therefore at last one node needs to be running Portowrx service.  The node IP or hostname is added as the last parameter to the command.

.PP
By default, the tool will target Portworx REST service running on \fB\fChttp://pxnode\-hostname\-or\-ip:9001\fR\&.
For clusters running OpenShift 4.3 (or higher), please use port \fB\fC17001\fR  (e.g. \fB\fCtrial\-license\-cleaner http://pxnode\-hostname\-or\-ip:17001\fR)

.SH Known Limitations
.RS
.IP \(bu 2
the tool does not automatically discover Portworx installations running on non\-default network port (:9001)
.RS
.IP \(bu 2
hint: one can pass full endpoint as parameter, to target a different port (e.g. \fB\fCtrial\-license\-cleaner \-v http://pxnode\-hostname\-or\-ip:17001\fR)

.RE

.IP \(bu 2
the tool does not support custom SSL certificates to access Portworx KVDB  (key\-value database)
.IP \(bu 2
the tool also does not support custom username/password to access Portworx KVDB
.IP \(bu 2
if \fB\fC\-\-restart\fR option provided, all Portworx nodes where license got corrected will be restarted; however, the restart will happen in parallel

.RE
